# -*- cperl -*-
package ConfigFile;
use strict;
use warnings;
our $CONFIG_FILE = 'config.txt';

my $loaded;
my @logs;

sub logs {
    _load();
    
    @logs;
}

sub _load {
    $loaded and return;
    $loaded = 1;

    open my $fh, '<', $CONFIG_FILE
      or die "Failed to read file $CONFIG_FILE";

    while (<$fh>) {
	tr/\r\n//d;
	m/^#/ and next;
	s/^\s*|\s*$//g;
	length or next;

	m/^(.+?)\s*:\s*(.+)$/ or
	  die "Bad line in the conf: $_";

	if ($1 eq 'logs') {
	    my $dict = _makedict($2);
	    defined $dict->{DIRECTORY} or
	      die "DIRECTORY not found: $2";
	    defined $dict->{CHANNEL} or
	      die "CHANNEL not found: $2";
	    push @logs, $dict;
	}
    }
}

sub _makedict {
    my $str = shift;
    my %dict;

    foreach (split m/\s*;\s*/, $str) {
	/^(.+?)\s*=\s*(.+)$/ or
	  die "Bad dict in the conf: $_";

	$dict{$1} = $2;
    }
    \%dict;
}

1;
