# -*- cperl -*-
package Huffcheap;
use strict;
use warnings;

use Data::Dumper;
$/ = undef;
compress(<>);

sub compress {
    my $data = shift;
    my $tree = _maketree($data);
    print "tree: ok\n";
    my $table = _maketable($tree);
    print "table: ok\n";

    my $out = '';
    # إå & ơ֥
    # FIXME

    # 
    my $body = Huffcheap::BitStream->new;
    foreach my $c (split //, $data) {
	$body->append_bitstream($table->[ord $c]);
    }
    print "input: ".length($data).", output: ".($body->num_of_bits / 8)."\n";
}

sub _maketree {
    my $data = shift;
    length($data) or die; # FIXME

    # ޤХȤνи٤
    my $toplevel = []; # ([count, undef, left, right] | [count, char]), ...
    foreach my $c (split //, $data) {
	my $char = $toplevel->[ord $c];
	if ($char) {
	    $char->[0]++;
	}
	else {
	    $toplevel->[ord $c] = [1, $c];
	}
    }
    @$toplevel = grep {defined} @$toplevel;

    # и٤㤤Τ˥ĥ꡼
    my $popmin = sub {
	my $min = 0;
	foreach (0 .. @$toplevel-1) {
	    $toplevel->[$_][0] < $toplevel->[$min][0] and
	      $min = $_;
	}
	splice @$toplevel, $min, 1;
    };
    while (@$toplevel > 1) {
	my $left = $popmin->();
	my $right = $popmin->();
	push @$toplevel, [
	    $left->[0] + $right->[0],
	    undef,
	    $left,
	    $right,
	   ];
    }

    $toplevel->[0];
}

sub _maketable {
    my $tree = shift;
    
    # ĥ꡼䤹ǥơ֥
    my $table = []; # Huffcheap::BitStream, ...
    do {
	my $maketable;
	$maketable = sub {
	    my ($pointer, $bitstream) = @_;
	    if (defined(my $c = $pointer->[1])) {
		# leaf
		#print "leaf: $c, bitstream: ".$bitstream->stringify,"\n";
		$table->[ord $c] = $bitstream;
	    }
	    else {
		# node
		$maketable->($pointer->[2], $bitstream->clone->append_bit(0));
		$maketable->($pointer->[3], $bitstream->clone->append_bit(1));
	    }
	};
	$maketable->($tree, Huffcheap::BitStream->new);
    };

    $table;
}

package Huffcheap::BitStream;
use strict;
use warnings;

sub new {
    my ($class) = @_;
    my $this = bless [] => $class;
    $this->[0] = 0; # num of bits
    $this;
}

sub clone {
    my $this = shift;
    my $new = bless [] => ref $this;
    @$new = @$this;
    $new;
}

sub num_of_bits {
    shift->[0];
}

sub append_bit {
    my ($this, $bit) = @_;
    $bit ||= 0;

    my $mod = $this->[0] % 8;
    if ($mod == 0) {
	# ˥Хɲ
	push @$this, $bit << 7;
    }
    else {
	# ǸΥХȤɲ
	$this->[int($this->[0] / 8) + 1] |= $bit << (7 - $mod);
    }
    $this->[0]++;
    $this;
}

sub append_bitstream {
    my ($this, $b) = @_;
    # FIXME: ٤
    my $s = $b->stringify;
    foreach (split //, $s) {
	$this->append_bit($_ eq '1' ? 1 : 0);
    }
    $this;
}

sub stringify {
    my $this = shift;
    my $str = '';
    for (my $i = 0; $i < $this->[0]; $i++) {
	$str .= $this->[int($i / 8) + 1] & (1 << (7 - $i % 8)) ? '1' : '0';
    }
    $str;
}
