# -*- cperl -*-
package LogFile;
use strict;
use warnings;
use IndexFile;
our $LOG_ROOT_DIR = 'logs';

sub months {
    # ('200401', '200402', ...)
    my $dirname = shift;

    my $dirpath = "$LOG_ROOT_DIR/$dirname";
    opendir my $dh, $dirpath
      or die "Failed to opendir $dirpath";
    my @months;
    while (defined($_ = readdir $dh)) {
	-d "$dirpath/$_" and /^\d{6}$/ and
	  push @months, $_;
    }

    @months;
}

sub days {
    # ('2004.01.01', '2004.01.02', ...)
    my ($dirname, $month) = @_;

    my $dirpath = "$LOG_ROOT_DIR/$dirname/$month";
    opendir my $dh, $dirpath
      or die "Failed to opendir $dirpath";
    my @days;
    while (defined($_ = readdir $dh)) {
	-f "$dirpath/$_" and /^(\d{4}\.\d{2}\.\d{2})\.txt$/ and
	  push @days, $1;
    }

    @days;
}

sub index {
    my ($dirname, $month, $day) = @_;
    IndexFile::get("$LOG_ROOT_DIR/$dirname/$month", $day);
}

sub last_modified {
    my ($dirname, $month, $day) = @_;
    my $fpath = "$LOG_ROOT_DIR/$dirname/$month/$day.txt";
    (stat($fpath))[9];
}

sub content {
    my ($dirname, $month, $day) = @_;
    my $fpath = "$LOG_ROOT_DIR/$dirname/$month/$day.txt";

    local $/ = undef;
    open my $dh, '<', $fpath;
    <$dh>;
}

1;
