#!/usr/bin/perl
# -*- cperl -*-

# このスクリプトは、次のようなログを

# 00:00:00 <#foobar:someone> hi all
# 00:00:01 + another (another!~another@foobar.org) to #foobar
# 00:00:02 someone -> SoMEoNe
# 00:00:03 ! another (bye)
# 00:00:04 - SoMEoNE from #foobar (bye)
# 00:00:05 Mode by OPBOT: #foobar +o Bot2
# 00:00:06 (#foobar:noticer) this is a notice
# 00:00:07 >#foobar:me< hi someone
# 00:00:08 Topic of channel #foobar by OPBOT: WeLCoME To #F00baR

# 次のように変更する。

# 00:00:00 <#foobar> hi all
# 00:00:01 + join #foobar
# 00:00:03 ! quit (bye)
# 00:00:04 - part #foobar (bye)
# 00:00:06 (#foobar) this is a notice
# 00:00:07 <#foobar> hi someone
# 00:00:08 topic #foobar WeLCoME To #F00baR

# 使い方: cat log/2004.01.01.txt | logfilter.pl > anonymous/2004.01.01.txt

my $re_time = qr/\d\d:\d\d(?::\d\d)?/;
my $re_channel = qr/[^\@:\s]+/;
while (<>) {
    chomp;
    if (/^($re_time) [<>]($re_channel).*?[<>] (.+)/) {
	# privmsg
	print "$1 <$2> $3\n";
    }
    if (/^($re_time) [()]($re_channel).*?[()] (.+)/) {
	# notice
	print "$1 ($2) $3\n";
    }
    elsif (/^($re_time) \+ .+? \(.+?\) to ($re_channel)/) {
	# join
	print "$1 + join $2\n";
    }
    elsif (/^($re_time) - .+? from ($re_channel)\S*(?: \((.*?)\))?/) {
	# part
	print "$1 - part $2 (".(defined $3 ? $3 : '').")\n";
    }
    elsif (/^($re_time) ! .+? \((.*?)\)/) {
	# quit
	print "$1 ! quit ($2)\n";
    }
    elsif (/^($re_time) Topic of channel ($re_channel)\S* by .+?: (.+)$/) {
	# topic
	print "$1 topic $2 $3\n";
    }
    # それ以外は捨てる
}
