#!/usr/bin/perl
# -*- cperl -*-
use strict;
use warnings;
use File::Path;

if (!@ARGV) {
    print "階層化されていないログファイルを階層化して複製する。\n";
    print "同時に lv -Ia -Ou8 によってUTF-8に変換し、\n";
    print "logfilter.pl による匿名フィルタも掛ける。\n";
    print "\n";
    print "使い方: storelog.pl --dest=remote/logs/NanminGoya ~/irclog/NanminGoya/*.txt\n";
    exit 1;
}

my $dest;
my @src;
foreach (@ARGV) {
    if (/^--dest=(.+)$/) {
	$dest = $1;
    }
    elsif (-r) {
	push @src, $_;
    }
    else {
	die "`$_' is not readable";
    }
}

if (!$dest) {
    die "missing argument --dest";
}

foreach my $src (@src) {
    if ($src =~ m,(?:^|/)(\d{4})\.(\d{2})\.(\d{2})\.txt$,) {
	my $destdir = "$dest/$1$2";
	if (!-d $destdir) {
	    mkpath $destdir, 1;
	}

	my $cmd = "lv -Ia -Ou8 $src | ./logfilter.pl > $destdir/$1.$2.$3.txt";
	print "$cmd\n";

	system($cmd);
    }
}
